
/*
 * DISCONNECT.C
 *
 * DISCONNECT <command>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/wait.h>

main(ac, av)
char *av[];
{
    int ttyfd = open("/dev/tty", O_RDWR);
    char *opts = "";

    if (av[1]) {
    	if (av[1][0] == '-') {
    	    opts = av[1];
    	    ++av;
	}
    }

    if (ttyfd >= 0) {
	ioctl(ttyfd, TIOCNOTTY, 0);
	close(ttyfd);
    }
    ttyfd = open("/dev/null", O_RDWR);

    if (strchr(opts, '0') == NULL && ttyfd != 0)
    	dup2(ttyfd, 0);
    if (strchr(opts, '1') == NULL && ttyfd != 1)
    	dup2(ttyfd, 1);
    if (strchr(opts, '2') == NULL && ttyfd != 2)
    	dup2(ttyfd, 2);

    if (ttyfd > 2)
    	close(ttyfd);

    signal(SIGCHLD, SIG_IGN);
    if (fork() == 0) {
	exit(execvp(av[1], av + 1));
    }
    exit(0);
}

